/*
 * Created on 16.12.2004
 *
 */
package net.hoopajoo.swingx;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.Action;
import javax.swing.JMenuItem;

/**
 * A special version of JMenuItem to be used with SelectedActions.
 * @author anttix
 */
public class JSelectedMenuItem extends JMenuItem {
    public JSelectedMenuItem(SelectedAction a) {
        super( a );
    }
    protected void configurePropertiesFromAction(Action a) {
        super.configurePropertiesFromAction( a );
        setText( (String)a.getValue( SelectedAction.SHORT_DESCRIPTION ));
        setActionCommand( (String)a.getValue( SelectedAction.ACTION_COMMAND_KEY ));
    }
    protected PropertyChangeListener createActionPropertyChangeListener(Action a) {
        a.addPropertyChangeListener( super.createActionPropertyChangeListener ( a ));
        
        return new PropertyChangeListener() {
        	public void propertyChange(PropertyChangeEvent evt) {
                if ( evt.getPropertyName().equals( SelectedAction.SHORT_DESCRIPTION ) ) {
                    setText( (String)evt.getNewValue() );
                }
                if ( evt.getPropertyName().equals( SelectedAction.ACTION_COMMAND_KEY ) ) {
                    setActionCommand( (String)evt.getNewValue() );
                }
            }
        };
    } 
}
